.arayna: module {
	.modulename: hAdv
	.type: text
	.moduleinfo {
		"A module to test the ability of Arayna"
		"This will simulate things that can be"
		"done in Paul Panc's HLAadventure"
	}
}

.include: "hlaadv_objects.inc"
.include: "hladev_events.inc"

.definearea: mistymtns, "Misty Mountains" {
	
	.room: guild, "Guild" {
		.desc:
  			"You are standing in a large guild room. A large crescent flag with a star emblazoned on it drapes down from the ceiling. A few tables and chairs are here, as well as a large fireplace."
  			"The fire is currently burning, illuminating the room in a soft glow. You notice some logs on the fire, burning quietly."
  		.links [ 0,0,3, .. ]	// links east to "Door"
  		.spawnobjects [ 1, flute ]
  		.spawnmonsters [ paladin ]
	}
	
	.room: 2, "Village Well" {
		.desc: "You are looking down on your reflection over a deep artisan well. The water rises some 100 feet below ground level, and the sides are green with moss. You don't notice if the water contains any of the moss from the walls, but it looks green nonetheless!"
		.links [ 4,5,6,3,.. ] // links west to "Door"
		.spawnmonsters [ villager ]
		.event: lockGuildDoor
	}
	
	.portal: guilddoor, "Guild Entrance" {
		.desc: "A wooden door that gives access to the Guild"
		.attributes [ @open | @close | @unlock | @lock | @examine ]
		.targets [1,2]	// between rooms 1 & 2
		.state [ @open ]
		.key: guildkey	
	}
	
	.room: 4, "Village path" {
		.desc: "You are standing on a path in the middle of town. The road is quite muddy, and you notice wheel ruts in the ground. To the east stands a village shop."
		.links [ tavern, 2, villagestore, 0, .. ]
	}
	
	.room: 5, "Entrance to town" {
		.desc: "You are standing near a stone archway. Vines grow on either pillar, snaking around the columns on both sides. The road into town heads north past an old cathedral. The cathedral itself is built on a steep hill, overlooking the village. Small plumes of smoke arise from the top."
		.links [ 2, 13, 0, 0, .. ]
	}
	
	.room: 6, "Small cathedral" {
		.desc: "You are standing in a small cathedral. Several pews adorn the room here, while high stained glass windows dominate the interior.  An altar stands to the north, near the back."
		.links [ 11, 0, 0, 2, .. ]
	}
	
	.room: tavern, "Village tavern" {
		.desc: "You are standing in a tavern with creaky wooden floors. Laughter and commotion surround you as the bartender tends to his customers. A few tables and chairs are visible here. A staircase heads upstairs to the second floor of the tavern. A sign reads 'Drink Cerveza!'"
		.links [ 0, 4, 0, 0, 0, 0, 0, 0, tavern2, 0 ]
		.spawnobjects [ rations(12) ]
	}
	
	.room: tavern2, "Upstairs hallway" {
		.desc: "You are standing on the upstairs hallway of the tavern. A few rooms are visible up ahead, the largest of which stands to the east. It appears unoccupied at the moment."
		.links [ 0, 0, 9, 0, 0, 0, 0, 0, 0, tavern ]
	}
	
	.room: 9, "Small room" {
		.desc: "You are standing in a small oom. It is mostly bare, save for a few wooden barrels. The only exit is back west."
		.links [ 0, 0, 0, tavern2, .. ]
		.spawnobjects [ lantern, food(12) ]
	}
	
	.room: villagestore, "Village store" {
		.desc: "You are standing in the village shop.  A clerk is normally here attending to customers. He seems friendly enough."
		.links [ 0, 0, 0, 4, .. ]
		.trader: 20
		.currency: currency
		.spawnmonsters [clerk]
		.spawnobjects [ oil, sword, cleaver ]
	}
	
	.room: 11, "Stone altar" {
		.desc: "You are facing a stone altar in the front of the cathedral.  The nave in the apse extends some twenty-five feet from center to ground. A small storage room is east. It looks a bit bare, but this church is fairly unadorned with items to begin with!"
		.links [ 0, 6, 12, .. ]	
	}
	
	.room: 12, "Storage room" {
		.desc: "You are standing inside a small storage room. It is used to store items pertaining to the church. However, some of these items do not even belong to the church! (go figure) The only exit is back west."
		.links [ 0, 0, 0, 11, .. ]
		.spawnobjects [ rope, guildkey ]
	}
	
	.room: 13, "Well-lit path" {
		.desc: "You are walking down a well-lit path beyond the forest.  The path heads north here past a stone archway. You also notice a well near the center of town.  A dusty path heads west for miles on end."
		.links [ 5, forestpath, 0, dustypath, .. ]
	}
	
	.room: forestpath, "Forest Path" {
		.desc: "You are walking down a narrow path near the outskirts of the forest. Trees surround you to the south, with a fork in the road visible nearby. It appears to branch out in four directions, heading into a thick haze."
		.links [ 13, 0, 0, 0, .. ]
	}
	
	.room: dustypath, "On a dusty path" {
		.desc: "You are walking on a dusty path heading west. It appears to extend a few miles towards the southwest. To the north of the path lies mystic mountains, bathed in a dull mist.  The path heads back east towards a small village."
		.links [ 0, 0, 13, 0, .. ]
	}
}



.begin {
	
	// spawnobject ( object to spawn, @player)
	// spawnobject ( object to spawn, area, room)
	.spawnobject ( currency (200), @player )	// give pc 200 gold to start
	
	
	.write (	
		"  A long time ago, when mystics, warriors and villagers with smelly socks roamed the land, things were great.  You could slay dragons, beat up no-good thieves, and even go on adventures with your drinking buddies. To add to it all, there was a princess to chase after and a king to swear allegiance to. All in all, life was grand."
		"  Until one day, that is...An evil dragon has taken refuge in a nearby cave. As the King's chief dragon hunter, it is up to you to slay the dragon dead. Good luck!"
	)
	.wait
	.teleport (1, guild)
	
}

.end


/*

	.setlink ( area, room, .direction, room#)
	
	


*/