
.const {
	mistymtns	= 1
	
	guild		= 1
	guilddoor	= 3
	tavern		= 7
	tavern2		= 8
	villagestore= 10
	forestpath	= 14
	dustypath	= 15

	paladin		= 1
	villager	= 2
	clerk		= 3

	guildkey	= 2
	flute		= 3
	lantern		= 4
	food		= 5
	rations		= 6
	oil			= 7
	sword		= 8
	cleaver		= 9
	rope		= 10
	currency	= 11
	chainlink	= 12
	scimitar	= 13
	shield		= 14
	
}

.global {
	quest_lantern	= 0

}

.defineobjects {

	.object: 1, "Bulletin Board" {
		.desc:
"
Quest#         Description                  Reward

1. Lantern    Find a missing lantern      100 gold
2. Goblin     Defeat an evil goblin       250 gold
3. Castle     Can you find the castle?    300 gold
4. Sorcerer   Find/dispatch the sorcerer  325 gold
5. Mansion    Explore a hidden mansion    ???
6. Werewolf   Befriend a lone werewolf    ???
7. Vampire    Vanquish the evil vampire   ???
8. Cavern     Defeat the evil guardian    ???
9. Dragon     This is the main quest      ???"

		.attributes [ @read ]
	}
	
	.object: guildkey, "key" {
		.desc: "A small wooden key."
		.attributes [ @get | @drop | @examine ]
	}
	
	.object: flute, "flute"	{
		.desc: "A small wooden flute"
		.attributes [ @get | @drop | @use | @examine ]
	}
	
	.object: lantern, "lantern" {
		.desc: "A brass lantern with rusted hinges."
		.attributes [ @general ]
		.event: lanternQuest
	}
	
	.object: food, "food" {
		.desc: "These are standard food rations, lasting two weeks."
		.attributes [ @fooditem ]
		.stack: 12
		.event: foodevent
	}
	
	.object: rations, "rations" {
		.desc: "These are standard iron rations (lasting two weeks)."
		.attributes [ @fooditem ]
		.stack: 12
		.event: foodevent
	}
	
	.object: oil, "oil" {
		.desc: "A flask of oil used with the lantern."
		.attributes [ @general]
		.value: 5
	}
	
	.wieldable: sword, "sword" {
		.desc: "A small metal sword with a diamond hilt."
		.attributes [@weaponitem]
		.value: 60
		.damage [ 1, 6 ]
		.hand: either
	}
	
	.wieldable: scimitar, "Scimitar" {
		// these are not accurate
		.desc: "A scimitar"
		.attributes [@weaponitem]
		.value: 300
		.damage [2, 8]
		.hand: primary	
	}
	
	.wearable: chainlink, "Chain Link Armor" {
		// these are not accurate
		.desc: "Chain link armor"
		.attributes [@wearable]
		.value: 300
		.ac: 10
		.physical: 10
	}
	
	.wieldable: shield, "Shield" {
		// these are not accurate
		.desc: "A small round shield"
		.attributes [@weaponitem]
		.value: 100
		.ac: 5
		.hand: secondary
	}
	
	.wieldable: cleaver, "cleaver" {
		.desc: "A dull meat cleaver, unevenly sharpened."
		.attributes [@weaponitem]
		.value: 150
		.hand: either
		.damage [ 1, 3 ]
	}
	
	.object: rope, "rope" {
		.desc: "A coil of rope about 20' long."
		.attributes [@general]
	}
	
	.object: currency, "Gold" {
		.desc: "Legal tender"
		.attributes [ @get | @examine ]
		.stack: @unlimited
	}
}


.defineagents {
	.monster: paladin, "Paladin" {
		.desc: "A strong paladin wearing a metal pendant.  He seems of noble blood"
		.level: 8
		.health: 95
		.attributes [ @examine | @talk | @attack ]
		.temperment: neutral
		.experience: 600
		.attack: 1 {
			.desc: "Slashes with Scimitar"
			.skill: 85
			.damage [ 2, 8 ]
		}
		.armor {
			.ac: 15
			.physical: 10
		}
		.event: paladinEvent
	}
	
	.monster: villager, "Villager" {
		.desc: "A common villager. He smiles at you briefly before passing."
		.level: 3
		.health: 55
		.attributes [ @examine | @talk | @attack ]
		.event: villagerEvent
		.temperment: neutral
		.experience: 200
		.attack: 1 {
			.desc: "Attacks"
			.skill: 44
			.damage [ 2, 6 ]
		}	
	}
	
	.monster: clerk, "clerk" {
		.desc: "A stout clerk. He looks well fed."
		.level: 3
		.health: 55
		.attributes [ @examine | @talk | @attack ]
		.event: clerkEvent
		.temperment: neutral
		.experience: 200
		.attack: 1 {
			.desc: "Attacks"
			.skill: 44
			.damage [ 2, 6 ]
		}	
	}
}	

.defineplayer: "Main PC" {
	.level: 1
	.special [ 6, 5, 6, 7, 6, 6, 4 ]	// totally unbalanced 'super' character!
}
