
.section: foodevent {
/*
	this event is called whenever a player performs an action
	on "food" and "ration" objects.
*/

	.local
	{
		restore = 0
	}
	
	.if ( .get(@lastaction) == @get) {
		.if ( .get(@lastobject)->number == food )
		{
			.write ( "Taken, Oh Sons of Greedy. :)" )
		}
	}
	
	.if ( .get(@lastaction) == @eat) {
		
		// eating food restores 3 health
		restore = .get(@player)->health
		restore += 3
		
		// but not more than max health
		.if ( restore > .get(@player)->maxhealth ) {
			restore = .get(@player)->maxhealth
		}
		.set ( @player, health, restore )
	}
	
}


.section: lanternQuest {

	.if ( .get(@lastaction) == @get) {
		.if ( quest_lantern == 0 ) {
			quest_lantern += 1
			.write ( "*** Lantern quest completed! ***" )
			.spawnobject ( currency (100), @player )
		}
	}
}

.section: villagerEvent {
	
	.local {
		x = 0
	}
	
	
	.if ( .get(@lastaction) == @talk) {
		.write ( "The villager says,'Please, leave me alone.'" )
	}
	
	// see if villager is alive
	x = .searchagent ( clerk, mistymtns, 2 )
	.if ( !x ) {
	
		// villager has been slain...
		
	}
	
}

.section: clerkEvent {
	
	.local {
		x = 0
	}
	
	.if ( .get(@lastaction) == @talk) {
		.write ( "The clerk says,'Well, what will it be, soldier?'" )
	}

	// see if clerk is alive	
	x = .searchagent ( villager, mistymtns, villagestore )
	.if ( !x ) {
	
		// clerk has been slain...
	}
}


.section: paladinEvent {
	.local {
		x = 0
	}
	
	.if ( .get(@lastaction) == @talk) {
		.write ( "The paladin laughs at you! He says,'What are you, some pathetic mortal?! Do us both a favor and grow a beard! Gain some weight!  And strap on some armor, for God-sake! You won't succeed long in the Misty Mountains without a good buckler or helmet to protect you. And you'll need some sort of weapon, perhaps the firewhip, hmmm? Oh, I see, you've got SOME items on your body, but nothing I'd buy for a dime!'" )	
	}
	
	x = .searchagent ( paladin, mistymtns, guild)
	.if ( !x ) {
	
		// paladin has been slain, spawn paladin's possessions
		// drop scimitar, shield and chainlink
		.spawnobject ( shield, mistymtns, guild )
		.spawnobject ( scimitar, mistymtns, guild )
		.spawnobject ( chainlink, mistymtns, guild )
	}

}

.section: lockGuildDoor {
	// when pc enters "Village Well", the portal to the
	// guild is locked.
	
	.if ( .get(@fromroom)->number == guild ) {
		.write ( "The guild door closes behind you as you leave, you hear the latch of a lock fall into place" )
		.setstate ( mistymtns, guilddoor, @close | @lock )
	}
}

