// sample module for Arayna
/*	map area 1
			  [secretroom]
					$
                [kitchen]
                    |
  [closet]-||- [tjunction] - || - [winding path]
                    |                   |       \
                [origin]                |     [path]
                                        |       |
                                  	  [end]---[hall]
										*
									[teleport to origin2]
	
*/
/* map area 2

		[origin2]
		   *
		  [teleport to end]
*/

// identify this as an arayna module and setup some informatio
.arayna: module	{
	.modulename: Sample		// name of module
	.moduleinfo {
		/*	information that is displayed when Info
			menu item is selected (not yet implemented!)
			all the strings are concatenated into one,
			a new line is assumed between " " pairs.
			the text below is treated as 3 lines
	
			the scanner ignores these for now
		*/
	
		"A sample Arayna module"
		"Created by Sevag Krikorian"
		"For testing purposes"
	
	}
	
	// game "type" currently only text is supported
	.type: text
}

.include: "samp.inc"

.section: endSequence {
	.write ("You have reached the end of the sample module")
	.endgame
}

.section: eTjunction {
	.write ( "room event at eTjunction" )
	sampleglobal = .get( @moves)
	.write ( "# of moves so far = ", sampleglobal )
	
	// lock the eastdoor if the player comes from
	// the closet room
	// you can trigger events in other areas as well
	// (not implemented yet, but the syntax covers it)
	// .setstate ( <area#>, <portal#>, <@state> )
	
	.if ( .get(@fromroom)->number == closet ) {
		.write ( " You hear a click from the east" )
		.setstate ( level1, eastdoor, @lock )
	}
	
//	sampleglobal = .removeobject ( potion, @player)
//	.write (sampleglobal->label, nl)
	
}

.section: area1Events {
//	.write ( "section: area1Events, this will run after every move" )
}

.section: kitchenEvent {

	.local {
		local1	= 0
		local2	= 200
		foundsecret = 0
	}
	
	.write ( "Entered section 'kitchenEvent'" )
	.write ( "Look at "".section: kitchenEvent"" in the sources to see what's going on." )
	.write ( "" )
	.if ( .get(@fromroom)->number == tjunction ) {
		.write ( "You arrived here from Junction" )
	}

	// @lastaction test
	.if ( .get(@lastaction) == @get) {
		.write ( "last action was get" )
	}
	.else {
		.write ( "last action was not get" )
	}

	sampleglobal = .get( @lastobject)
	.write ( "last object manipulated : ", sampleglobal )
	.write ( " " )
	
	.if ( samplestring == "Sample String" ) {
		.write ( "yes" )
	}
	.else {
		.write ( "no" )
	}
	
//	samplestring += " cat test."
//	.write ( samplestring )
	
	local1 = 500
	
	.write ( "Sample local, local1 = ", local1 )
	.write ( "Sample local, local2 *2 = ", local2 *2 )
	
//	local1 = .skillcheck ( perception, 150 )
//	.write ( "Skillcheck : ", local1 )
	
	.if ( .get(@lastaction) == @search) {
		.if (foundsecret) {
			.write ("You find nothing more")
		}
		.else {
			.if ( .skillcheck ( perception, 150) > 0 ) {
				foundsecret += 1
				.write ("You discover a false wall to the north!")
				.setlink ( level1, kitchen, north, secretroom )
			}
			.else {
				.write ( "perception test failed!")
			}
		}
	}
}

// define an 'area' #1
.definearea: level1, "Temple" {
	
	.room: closet, "Closet"
	{
		.desc: 
			"  Just as you suspected, an old storage room"
			"filled with broken down junk."
			" "
			"The only exit is also the entrance."
			
		.experience: 0
		//.links [ n, s, e, w, ne, nw, se, sw, u, d ]
		// a quick way to set up exits
		.links [0, 0 , closetdoor, 0, 0, 0, 0, 0, 0, 0 ]
		.spawnobjects [ lantern, stone ]
	}
			
	.room: tjunction, "Junction"
	{
		.desc:
			"  The wide hallway is littered with broken, moulding"
			"furniture, sadly, you see nothing worth looting."
			" "
			"At the end, the path ends at a 'T' junction"
			" "
			"There is a doorway to the west."
			"To the east, the path continues and curves"
			"south, a wide hall leads south to the main"
			"entrance."
		
		.experience: 1
		.links [ kitchen, origin, eastdoor, closetdoor, .. ]
		.event: eTjunction
	}
			
	.room: origin, "Origin"
	{
		.desc: 
			"  After a long journey, you finally arrive at your"
			"destination.  The Temple of Arbalis looms before you"
			"surrounded by overgrown vegetation from years of"
			"neglect."
			"  The huge, broken down double doors offer little"
			"resistance as you enter into the darkness."
			"Inside is not as dark as it seemed from outside,"
			"rays of sun light enter through the cavities that"
			"once contained stained glass windows."
			" "
			"The wide hallway extends north before you."
			
		.experience: 1
		.links [ tjunction, .. ]
		
		// new, stacked items: use parenthesis to indicate amount
		.spawnobjects [ rustykey, gold (50), sword, potion, leather ]
		.event: originEvent
	}
			
	.room: windingpath, "Winding Path"
	{
		.desc: 
			"  Here the path splits, continuing southeast and south."
			"Shop emulation here"
		
		.trader: 20
		.currency: gold
		.experience: 1
		.links [ 0, end, 0, eastdoor, 0, 0, path, .. ]
		.spawnobjects [ buckle, sword ]
	}
			
	.room: path, "A path"
	{
		.desc: 
			"  The path continues for a short distance and"
			"straightens out into a south leading passage."
			
		.experience: 1
		.links [ 0, hall, 0, 0, 0, windingpath, .. ]
	}
			
	.room: hall, "A hallway"
	{
		.desc: 
			"  You reach a lesser hall that once housed roomes leading"
			"to the chambers of the priests."
			" "
			"North goes back to the winding passage"
			"To the west, you see a smaller passage."
			
		.experience: 1
		.links [ path, 0, 0, end, .. ]
		.spawnobjects [ pen ]
	}
	
	.room: end, "Fountain"
	{
		.desc: 
			"  You have reached a large circular room with a"
			"dried out circular fountain in the center."
			"At one time, this fountain was visited by people"
			"from many weeks' travel with the hope of expressing"
			"their wishes to Arbalis."
			" "
			"Now, the fountain is as much forgotten as the god that"
			"once served it."
			" "
			"The east path leads to the Priest's chambers"
			"To the north is a narrow passage."
			"There is an old rope decending into the depths of the fountain"
			
		.experience: 2
		.links [ windingpath, 0, hall, .. ]
		.spawnobjects [ fountainrope ]
		.spawnmonsters [ 1 ]
	}
	
	.portal: closetdoor, "Door"
	{
		.desc: "An ancient wooden door"
		
		// actions that can be performed on this portal
		.attributes [ @open | @close | @unlock | @lock | @examine ]
		
		// current state of this portal
		.state [ @close | @lock ]	// closed and locked
		
		// 2 room numbers between which is located this portal.
		.targets [ tjunction, closet ]

		// choosing "unlock" this portal's menu checks to see if the player
		// has object # 'rustykey', and unlocks the door with it automatically
		// (no need to "use key") 
		.key: rustykey
	}
	
	.portal: eastdoor, "Door"
	{
		.desc: "A door"
		.attributes [ @open | @close | @unlock | @lock | @examine ]
		.state [ @open ]
		.targets [ tjunction, windingpath ]
		.key: rustykey		// why not, same key to open 2 doors
	}
	
	.room: kitchen, "Kitchen"
	{
		.desc: "Broken tables, chairs and rusting pots are strewn in a random pattern around what once used to be a kitchen serving the priests."
		.experience: 2
		.links [0, tjunction, .. ]
		.event: kitchenEvent
	}
	
	.room: secretroom, "Secret Room"
	{
		.desc: "You have stumbled onto the secret treasure hoard of the temple!"
		.experience: 10
		
		// no link leads to this room, it will be set dynamically
		// if "Search" is used on the Kitchen room.
		.links [ 0, kitchen, .. ]
		.event: endSequence
	}
	
	.event: area1Events
}

//=======================================================================================

.definearea: level2, "Catacombs" {

	.room: origin2, "Dark cave" {
		.desc: "You are in a dark and dank cave at the bottom of a fountain.  A rope leads up towards a glow of a faint light."
		.experience: 10
		.spawnobjects [ fountainrope ]
		.event: catacombEvent
	}	
}


.section: endGameSection {
	.write ("You have died." nl)
	.endgame
}

.section: originEvent {
	.local {
		entry 	= 0
		obj		= 0
	}
	
	.if (entry == 0) {
		entry += 1
		obj = .removeobject ( stone, level1, tjunction)
//		.write ( "removed ", obj->label, " from tjunction, destroying...", nl )
//		.destroyobject ( obj )
		.write ( "removed ", obj->label, " relocating to room ""Secret Room""" , nl)
		.setobject ( obj, level1, secretroom )
		
	}
}

.begin {	

	// output some text to the main display.
	.write ( "Welcome to Arayna sample module.  This short 'adventure' attempts to cover all aspects of the scripting language available in Arayna." )
	.write ( "" )
	.write ( "Some integrity tests follow" )
	.write ( "Global var test, sampleglobal *2 = ", sampleglobal *2 )
	.write ( "Global string test, samplestring = ", samplestring )
	.write ( "Global float test, samplefloat   = ", samplefloat )
	.write ( "Constant test, strconst          = ", strconst )
	.if ( sampleglobal == -100 )
	{
		.write ( "true" )
	}
	.else {
		.write ( "false" )
	}
	
	.if ( samplefloat == 24.4 )
	{
		.write ( "samplefloat is 24.4" )
	}
	.else
	{
		.write ( "samplefloat is not 24.4" )
	}
	.write ( "after if test" )

	
	// spawnobject syntax:
	// spawnobject ( object to spawn, @player)
	// spawnobject ( object to spawn, area, room)
	// (not yet) spawnobject ( object to spawn, area, room, container)
	// spawn a stone
	.spawnobject ( stone, level1, tjunction ) 
	

	.if  ( .skillcheck ( traps, 100 ) > 0 ) {
		.write ("Traps skill check passed")
	}
	.else {
		.write ("Traps skill check failed")
	}

	// so that Arayna knows where to go if the pc manages
	// to get himself killed.
	.setendgame: endGameSection
	
	// wait for mouseclick input before continuing.
	.wait
	
	// cls clears the main text window
	.cls
	

	// place the player's starting location
	.teleport (level1, origin)
	
	another = .searchobject ( potion, level1, origin)
	.if (another)
	{
		.write ( ".searchobject test, found: ", another->label , nl)
	}
	.else
	{
		.write ( ".searchobject test, failed", nl)
	}
	
	.write ( ".searchagent test" ,nl)
	another = .searchagent ( 1, level1, end )
	.if (another)
	{
		.write ("found ", another->label, " passed",nl)
	}
	another = .searchagent (1, level1, tjunction)
	.if (! another)
	{
		.write ("Giant Rat not found in ""Junction"", passed",nl)
	}
	
}

// from this point, the game will wait for user
// input from the GUI
.end



/*
	.spawnobject creates an object from the object definitions
	.spawnobject ( object to spawn, @player)
	.spawnobject ( object to spawn, area, room)
	.spawnobject ( object to spawn, area, room, container/agent) - not yet
	

	.setlink ( area, room, direction, target room)
	-direction is north, south, east, west, etc.
	
	.setstate ( area, portal, @state )
	.setstate ( area, room, container, @state ) - not yet
	
********* new ***************
	.skillcheck ( skill, target )
	-skill is st, pe, en, ch, in, ag, lk for checkes against physical attributes.
	-skill is unarmed, armed, ranged, thrown, heal, sneak, lockpick, steal, traps,
				repair, barter, gamble, survival for checks against skills
	-target = 1 - 200, where 200 is near impossible, and 1 guarantees sussess all the time.
		return is <=0 for failure, >0 for success.  The amount above/below zero determines
		significance of success/failure.
	(there is really no upper limit, algo is 1d100 + [ skill | (attribute *10)] - target > 0 for success)
	returns > 1 for success.  Better success = higher return.
	retruns <= 0 for failure.  Worse failure = lower return.
	
	eg:
	result = .skillcheck ( agility, 150 )
	.if ( .skillcheck ( strength, 100 ) > 0 ) {
		// skill passed
	}
	
	axed: .toughness, .locklevel	these will be taken care of
	source level in the script.
	
****	todo for next	*****
	these return objectptr
	<objptr> = .removeobject ( object to remove, @player)  - done
	<objptr> = .removeobject ( object to remove, area, room) -done
	<objptr> = .removeobject ( object to remove, area, room, container ) - not yet
	
	.destroyobject (objptr)		-done	// a good idea to keep memory usage down
	.setobject (objptr, @player)	-done
	.setobject (objptr, area, room)	-done
	.setobject (objptr, area, room, container) - not yet
	
	<objptr> = .searchobject ( object to search, @player)	-done
	<objptr> = .searchobject ( object to search, area, room)-done
	<objptr> = .searchobject ( object to search, area, room, container)  -not yet
	
	<objptr> = .searchagent ( agent to search, area, room )
		
	.set ( @player, attribute, value)	-done
	.set ( room, agent, attribute, value) -not yet
	
	
	wearable
	container
*/
